
package orbasec.krb5;


public /*synchronized*/ class gss
{

	/**
	 * Flag bits for context-level services.
	 */
	public final static int 
		GSS_C_DELEG_FLAG	  = 1,   // 0x001
		GSS_C_MUTUAL_FLAG	  = 2,   // 0x002
		GSS_C_REPLAY_FLAG	  = 4,   // 0x004
		GSS_C_SEQUENCE_FLAG   = 8,   // 0x008
		GSS_C_CONF_FLAG 	  = 16,  // 0x010
		GSS_C_INTEG_FLAG	  = 32,  // 0x020
		GSS_C_ANON_FLAG 	  = 64,  // 0x040
		GSS_C_PROT_READY_FLAG = 128, // 0x080
		GSS_C_TRANS_FLAG      = 256; // 0x100
	/**
	 * Credential usage options
	 */
	public final static int 
		GSS_C_BOTH  		 = 0,
		GSS_C_INITIATE  	 = 1,
		GSS_C_ACCEPT		 = 2;
		
	/**
	 * Status code types for gss_display_status
	 */
	public final static int 
		GSS_C_GSS_CODE       = 1,
		GSS_C_MECH_CODE      = 2;

	/**
	 * The constant definitions for channel-bindings address families
	 */
	public final static int 
		GSS_C_AF_UNSPEC 	= 0,
		GSS_C_AF_LOCAL  	= 1,
		GSS_C_AF_INET		= 2,
		GSS_C_AF_IMPLINK	= 3,
		GSS_C_AF_PUP		= 4,
		GSS_C_AF_CHAOS  	= 5,
		GSS_C_AF_NS 		= 6,
		GSS_C_AF_NBS		= 7,
		GSS_C_AF_ECMA		= 8,
		GSS_C_AF_DATAKIT	= 9,
		GSS_C_AF_CCITT  	= 10,
		GSS_C_AF_SNA		= 11,
		GSS_C_AF_DECnet 	= 12,
		GSS_C_AF_DLI		= 13,
		GSS_C_AF_LAT		= 14,
		GSS_C_AF_HYLINK 	= 15,
		GSS_C_AF_APPLETALK  = 16,
		GSS_C_AF_BSC		= 17,
		GSS_C_AF_DSS		= 18,
		GSS_C_AF_OSI		= 19,
		GSS_C_AF_X25		= 21,
	
		GSS_C_AF_NULLADDR	= 255;
		
	/**
	 * Some "helper" definitions to make the status code macros obvious.
	 */
	public final static int 
		GSS_C_CALLING_ERROR_OFFSET = 24,
		GSS_C_ROUTINE_ERROR_OFFSET = 16,
		GSS_C_SUPPLEMENTARY_OFFSET = 0,
		GSS_C_CALLING_ERROR_MASK   = 0377,
		GSS_C_ROUTINE_ERROR_MASK   = 0377,
		GSS_C_SUPPLEMENTARY_MASK   = 0177777;
		
	public final static int
	CALLING_ERROR(int x) 
	{
		return
			((x) & (GSS_C_CALLING_ERROR_MASK << GSS_C_CALLING_ERROR_OFFSET));
	}
	
	public final static int
	ROUTINE_ERROR(int x) 
	{
		return
			((x) & (GSS_C_ROUTINE_ERROR_MASK << GSS_C_ROUTINE_ERROR_OFFSET));
	}
	
	public final static int
	SUPPLEMENTARY_INFO(int x)
	{
		return
			((x) & (GSS_C_SUPPLEMENTARY_MASK << GSS_C_SUPPLEMENTARY_OFFSET));
	}
	
	public final static int
	ERROR(int x) 
	{
		return
			((x) & 
			 (  (GSS_C_CALLING_ERROR_MASK << GSS_C_CALLING_ERROR_OFFSET)
			  | (GSS_C_ROUTINE_ERROR_MASK << GSS_C_ROUTINE_ERROR_OFFSET)));
	}
	
	public final static int
		GSS_S_COMPLETE                = 0;
		
	/**
	 * Calling errors:
	 */
	public final static int 
		GSS_S_CALL_INACCESSIBLE_READ  = 1 << GSS_C_CALLING_ERROR_OFFSET,
		GSS_S_CALL_INACCESSIBLE_WRITE = 2 << GSS_C_CALLING_ERROR_OFFSET,
		GSS_S_CALL_BAD_STRUCTURE      = 3 << GSS_C_CALLING_ERROR_OFFSET;
	
	/**
	 * Routine errors:
	 */
	public final static int 
		GSS_S_BAD_MECH              = 1  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_BAD_NAME              = 2  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_BAD_NAMETYPE          = 3  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_BAD_BINDINGS          = 4  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_BAD_STATUS            = 5  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_BAD_SIG               = 6  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_NO_CRED               = 7  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_NO_CONTEXT            = 8  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_DEFECTIVE_TOKEN       = 9  << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_DEFECTIVE_CREDENTIAL  = 10 << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_CREDENTIALS_EXPIRED   = 11 << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_CONTEXT_EXPIRED       = 12 << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_FAILURE               = 13 << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_BAD_QOP               = 14 << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_UNAUTHORIZED          = 15 << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_UNAVAILABLE           = 16 << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_DUPLICATE_ELEMENT     = 17 << GSS_C_ROUTINE_ERROR_OFFSET,
		GSS_S_NAME_NOT_MN           = 18 << GSS_C_ROUTINE_ERROR_OFFSET;
		
	/**
	 * Supplementary info bits:
	 */
	public final static int 
		GSS_S_CONTINUE_NEEDED = (1 << (GSS_C_SUPPLEMENTARY_OFFSET + 0)),
		GSS_S_DUPLICATE_TOKEN = (1 << (GSS_C_SUPPLEMENTARY_OFFSET + 1)),
		GSS_S_OLD_TOKEN       = (1 << (GSS_C_SUPPLEMENTARY_OFFSET + 2)),
		GSS_S_UNSEQ_TOKEN     = (1 << (GSS_C_SUPPLEMENTARY_OFFSET + 3)),
		GSS_S_GAP_TOKEN       = (1 << (GSS_C_SUPPLEMENTARY_OFFSET + 4));
		
	/**
	 * Various Null Values. Whatch it, if you use these in
	 * return value parameters, they may change their handle
	 * value, which wouldn't make them constants any more.
	 */
	public final static byte[]                 GSS_C_NO_BUFFER         = null;
	public final static gss_OID                GSS_C_NO_OID            = 
	                                                   new gss_OID();
	public final static gss_OID_set            GSS_C_NO_OID_SET        = 
	                                                  new gss_OID_set();
	public final static gss_ctx_id_t           GSS_C_NO_CONTEXT        = 
	                                                  new gss_ctx_id_t();
	public final static gss_cred_id_t          GSS_C_NO_CREDENTIAL     = 
	                                                  new gss_cred_id_t();
	public final static gss_channel_bindings_t GSS_NO_CHANNEL_BINDINGS = 
	                                                  new gss_channel_bindings_t();

	/*
	 * Some alternate names for a couple of the above values.  These are defined
	 * for V1 compatibility.
	 */
	public final static gss_OID     GSS_C_NULL_OID	   = GSS_C_NO_OID;
	public final static gss_OID_set GSS_C_NULL_OID_SET = GSS_C_NO_OID_SET;

	/**
	 * Define the default Quality of Protection for per-message services.  Note
	 * that an implementation that offers multiple levels of QOP may either reserve
	 * a value (for example zero, as assumed here) to mean "default protection", or
	 * alternatively may simply equate GSS_C_QOP_DEFAULT to a specific explicit
	 * QOP value.  However a value of 0 should always be interpreted by a GSSAPI
	 * implementation as a request for the default protection level.
	 */
	public final static int GSS_C_QOP_DEFAULT = 0;
	
	/*
	 * These are not part of the GSSAPI C bindings!  (but should be)
	 */

	public final static int
	GSS_CALLING_ERROR_FIELD(int x)
	{
		return
			(((x) >> GSS_C_CALLING_ERROR_OFFSET) & GSS_C_CALLING_ERROR_MASK);
	}
	
	public final static int
	GSS_ROUTINE_ERROR_FIELD(int x)
	{
		return 
		    (((x) >> GSS_C_ROUTINE_ERROR_OFFSET) & GSS_C_ROUTINE_ERROR_MASK);
	}
	
	public final static int
	GSS_SUPPLEMENTARY_INFO_FIELD(int x)
	{
		return
		 (((x) >> GSS_C_SUPPLEMENTARY_OFFSET) & GSS_C_SUPPLEMENTARY_MASK);
	}

	/**
	 * This is a necessary evil until the spec is fixed
	 */
	public final static int
		GSS_S_CRED_UNAVAIL = GSS_S_FAILURE;

	/*
	 * The following OIDs from gssapi_generic.h need to have
	 * there handles filled in with an initilaization function.
	 */
	public final static gss_OID
		gss_nt_user_name        = new gss_OID(),
		gss_nt_machine_uid_name = new gss_OID(),
		gss_nt_string_uid_name  = new gss_OID(),
		gss_nt_service_name     = new gss_OID();
	
	public final static Version version = new Version();
	
	// This static initializer block must be below the attribute
	// declarations.
	static {
		System.loadLibrary("Jgsskrb5");
		initialize();
	}
	
	public static class Version {
		public int major;
		public int minor;
	};
	
	
	public final static synchronized native int get_gss_nt_user_name();
	public final static synchronized native int get_gss_nt_machine_uid_name();
	public final static synchronized native int get_gss_nt_string_uid_name();
	public final static synchronized native int get_gss_nt_service_name();
	public final static synchronized native int get_gss_library_version_major();
	public final static synchronized native int get_gss_library_version_minor();
	
	public final static void
	initialize()
	{
		gss_nt_user_name.handle        = get_gss_nt_user_name();
		gss_nt_machine_uid_name.handle = get_gss_nt_machine_uid_name();
		gss_nt_string_uid_name.handle  = get_gss_nt_string_uid_name();
		gss_nt_service_name.handle     = get_gss_nt_service_name();
		version.major                  = get_gss_library_version_major();
		version.minor                  = get_gss_library_version_minor();
	}
	
	public final static synchronized native int
	accept_sec_context( gss_int_holder         minor_status,
	                    gss_ctx_id_t           context_handle,
	                    gss_cred_id_t          verifier_cred_handle,
	                    byte[]                 input_token,
	                    gss_channel_bindings_t input_chan_bindings,
	                    gss_name_t             src_name,
	                    gss_OID                mech_type,
	                    gss_buffer_holder      output_token,
	                    gss_int_holder         ret_flags,
	                    gss_int_holder         time_rec,
	                    gss_cred_id_t          delegated_cred_handle);
	                    
	public final static synchronized native int
	acquire_cred( gss_int_holder   minor_status,
	              gss_name_t       desired_name,
	              int              time_req,
	              gss_OID_set      desired_mechs,
	              int              cred_usage,
	              gss_cred_id_t    output_cred_handle,
	              gss_OID_set      actual_mechs,
	              gss_int_holder   time_rec);
	                    
	/* V2 */
	public final static synchronized native int
	add_cred( gss_int_holder    minor_status,
	          gss_cred_id_t  	input_cred_handle,
	          gss_name_t     	desired_name,
	          gss_OID        	desired_mech,
	          int               cred_usuage,
	          int               initiator_time_req,
	          int               acceptor_time_req,
	          gss_cred_id_t     output_cred_handle,
	          gss_OID_set       actual_mechs,
	          gss_int_holder    initiator_time_rec,
	          gss_int_holder    acceptor_time_rec);
	          
	/* V2 */
	public final static synchronized native int
	add_oid_set_member( gss_int_holder    minor_status,
	                    gss_OID           member_oid,
	                    gss_OID_set       oid_set );
	 
	public final static synchronized native int
	compare_name( gss_int_holder   minor_status,
	              gss_name_t 	   name1,
	              gss_name_t 	   name2,
	              gss_int_holder   name_equal);
	              
	public final static synchronized native int
	context_time( gss_int_holder    minor_status,
	              gss_ctx_id_t      context_handle,
	              gss_int_holder    time_rec);
	              
	public final static synchronized native int
	create_empty_oid_set( gss_int_holder   minor_status,
	                      gss_OID_set      oid_set );
	
	public final static synchronized native int
	delete_sec_context( gss_int_holder    minor_status,
	                    gss_ctx_id_t      context_handle,
	                    gss_buffer_holder output_token );
	                    		          
	public final static synchronized native int
	display_name( gss_int_holder    minor_status,
	              gss_name_t        input_name, 
	              gss_string_holder output_name_buffer, 
		          gss_OID           output_name_type);
	
	public final static synchronized native int
	display_status( gss_int_holder    minor_status,
	                int         	  status_value,
	                int         	  status_type,
	                gss_OID     	  mech_type,
	                gss_int_holder    message_context,
	                gss_string_holder status_string );
	                
	/* V2 */
	public final static synchronized native int
	export_sec_context( gss_int_holder      minor_status,
	                    gss_ctx_id_t        context_handle,
	                    gss_buffer_holder   interprocess_token);
	                        
	/* V2 */
	public final static synchronized native int
	get_mic( gss_int_holder    minor_status,
	         gss_ctx_id_t 	   context_handle,
	         int           	   qop_req,
	         byte[]       	   message_buffer,
	         gss_buffer_holder message_token );
	                            
	public final static synchronized native int
	import_name( gss_int_holder    minor_status,
	             String            input_name_buffer, 
	             gss_OID           input_name_type, 
	             gss_name_t        name);
	             
	/* V2 */
	public final static synchronized native int
	import_sec_context( gss_int_holder    minor_status,
	                    byte[]            interprocess_token,
	                    gss_ctx_id_t      context_handle );
	       
	public final static synchronized native int
	indicate_mechs( gss_int_holder    minor_status,
	                gss_OID_set       mech_set );
	
	public final static synchronized native int
	init_sec_context ( gss_int_holder         minor_status,
	                   gss_cred_id_t 		  claimant_cred_handle,
     				   gss_ctx_id_t  		  context_handle,
     				   gss_name_t    		  target_name,
     				   gss_OID       		  mech_type,
     				   int           		  req_flags,
     				   int                    time_req,
     				   gss_channel_bindings_t input_chan_bindings,
     				   byte[]                 input_token,
     				   gss_OID                actual_mech_type,
     				   gss_buffer_holder      output_token,
     				   gss_int_holder         ret_flags,
     				   gss_int_holder         time_rec);

	public final static synchronized native int
	inquire_context( gss_int_holder minor_status,
	                 gss_ctx_id_t 	context_handle,
     				 gss_name_t   	initiator_name,
     				 gss_name_t   	acceptor_name,
     				 gss_int_holder lifetime_rec,
     				 gss_OID      	mech_type,
     				 gss_int_holder ret_flags,
     				 gss_int_holder locally_initiated,
     				 gss_int_holder open);

	public final static synchronized native int
	inquire_cred( gss_int_holder   minor_status,
	              gss_cred_id_t    cred_handle,
                  gss_name_t       name,
                  gss_int_holder   lifetime_ret,
                  gss_int_holder   cred_usage,
                  gss_OID_set      mechanisms);

	/* V2 */
	public final static synchronized native int
	inquire_cred_by_mech( gss_int_holder   minor_status,
	                      gss_cred_id_t    cred_handle,
                          gss_OID          mech_type,
                          gss_name_t       name,
                          gss_int_holder   initiator_lifetime,
                          gss_int_holder   acceptor_lifetime,
                          gss_int_holder   cred_usage);

	/* V2 */
	public final static synchronized native int
	oid_to_str( gss_int_holder      minor_status,
	            gss_OID             oid,
                gss_string_holder   oid_str);

	// WARNING: The order of these parameters is not the same as in the GSS
	public final static synchronized native int
	process_context_token( gss_int_holder    minor_status,
                           byte[]            token_buffer,
	                       gss_ctx_id_t      context_handle);

	public final static synchronized native int
	release_cred( gss_int_holder    minor_status,
	              gss_cred_id_t     cred_handle);

	public final static synchronized native int
	release_name( gss_int_holder    minor_status,
	              gss_name_t        input_name);

    // Not needed since buffers never make it out of gss calls.
// 	public final static native int
// 	gss_release_buffer( gss_int_holder    minor_status,
// 	                    gss_buffer_t buffer );

	/* V2 */
	public final static synchronized native int
	release_oid( gss_int_holder    minor_status,
	             gss_OID oid );

	public final static synchronized native int
	release_oid_set( gss_int_holder    minor_status,
	                 gss_OID_set set );

	/* V1 only */
	public final static synchronized native int
	seal( gss_int_holder    minor_status,
	      gss_ctx_id_t      context_handle,
          int               conf_req_flag,
          int               qop_req,
          byte[]            input_message_buffer,
          gss_int_holder    conf_state,
          gss_buffer_holder output_message_buffer);

	public final static synchronized native int
	sign( gss_int_holder    minor_status,
	      gss_ctx_id_t  	context_handle,
          int           	qop_req,
          byte[]         	message_buffer,
          gss_buffer_holder message_token);

	/* V2 */
	public final static synchronized native int
	verify_mic( gss_int_holder    minor_status,
	            gss_ctx_id_t	  context_handle,
                byte[]       	  message_buffer,
                byte[]       	  token_buffer,
                gss_int_holder    qop_state);

	/* V2 */
	public final static synchronized native int
	wrap( gss_int_holder    minor_status,
	      gss_ctx_id_t      context_handle,
          int				conf_req_flag,
          int				qop_req,
          byte[]			input_message_buffer,
          gss_int_holder	conf_state,
          gss_buffer_holder output_message_buffer);

	/* V2 */
	public final static synchronized native int
	str_to_oid( gss_int_holder    minor_status,
	            String            oid_str,
                gss_OID           oid);

	/* V2 */
	public final static synchronized native int
	test_oid_set_member( gss_int_holder    minor_status,
	                     gss_OID           member,
                         gss_OID_set       set,
                         gss_int_holder    present);

	/* V1 only */
	public final static synchronized native int
	unseal( gss_int_holder    minor_status,
	        gss_ctx_id_t      context_handle,
            byte[]            input_message_buffer,
            gss_buffer_holder output_message_buffer,
            gss_int_holder    conf_state,
            gss_int_holder    qop_state);

	/* V2 */
	public final static synchronized native int
	unwrap( gss_int_holder    minor_status,
	        gss_ctx_id_t      context_handle,
            byte[]            input_message_buffer,
            gss_buffer_holder output_message_buffer,
            gss_int_holder    conf_state,
            gss_int_holder    qop_state);

	/* V1 only */
	public final static synchronized native int
	verify( gss_int_holder    minor_status,
	        gss_ctx_id_t      context_handle,
            byte[]            message_buffer,
            byte[]            token_buffer,
            gss_int_holder    qop_state);

	/* V2 */
	public final static synchronized native int
	wrap_size_limit( gss_int_holder    minor_status,
	                 gss_ctx_id_t	   context_handle,
                     int			   conf_req_flag,
                     int               qop_req, /* should be gss_qop_t */
                     int               req_output_size,
                     gss_int_holder    max_input_size );

	//
	// Helper Functions.
	//
	public final static native int
	create_channel_bindings(
					 int    initiator_addrtype,
					 byte[] initiator_address,
					 int    acceptor_addrtype,
					 byte[] acceptor_address,
					 byte[] application_data,
					 gss_channel_bindings_t chan_bindings);
	
	public final static native int
	release_channel_bindings(
					gss_channel_bindings_t chan_bindings);
					
	//
	// Hack! Need to get kerberos to switch the cache file
	// since import of delegation will kill the cache.
	
	// If the name is null, then that resets the cache file to 
	// be the default, i.e in Unix /tmp/krb5cc_[uid], etc.
	public final static synchronized native void
	krb_set_cache( String cache_file );
	//
	// Hack! Need to get kerberos to switch the cache file
	// since import of delegation will kill the cache.
	// If the name is null, then that resets the keytab file to
	// be the system default.
	public final static synchronized native void
	krb_set_keytab( String keytab_file );
	
	public final static synchronized native void
	krb_set_config_file( String config_file );
}
	
	
	
	
