//tabstop=4
//*****************************************************************************/
// Project: Orbasec
//
// File:    GSSError.java
// Date:    March 1998
//
// -------------------------------------------------------------------------
// Copyright (C) 1998 Polar Humenn
//                    All rights reserved.
// -------------------------------------------------------------------------
// $Id$
//*****************************************************************************/
package orbasec.secrep.gsskrb5;

import orbasec.krb5.*;

//----------------------------------------------------------------------/
// GSSError
/**
 * This class is an Error class that may printout a message.
 * 
 * @version $Revision$
 * @see     
 */
// Implementation notes:  
// 
//----------------------------------------------------------------------/
public class GSSError
	extends RuntimeException
{
	GSSError( String msg, int major, int minor )
	{
		super(display_status(msg,major,minor));
	}
	
	GSSError()
	{
		super("GSS-API error");
	}
		
	private static String
	display_status_1(String msg, int code, int type)
	{
		int maj_stat;
		gss_int_holder    min_stat        = new gss_int_holder();
		gss_string_holder s               = new gss_string_holder();
		gss_int_holder    message_context = new gss_int_holder();
		
		StringBuffer msgb = new StringBuffer();
		
		message_context.value = 0;
		while(true) {
		   gss.display_status(min_stat, code, type,
		                   gss.GSS_C_NO_OID,
		                   message_context, s);
		   msgb.append("GSS-API error (");
		   msgb.append(Integer.toHexString(type));
		   msgb.append(",");
		   msgb.append(Integer.toHexString(code) + ") ");
		   msgb.append(msg + ": " + s.buffer());
		   msgb.append("\n");
		   if (message_context.value == 0)
		      break;
		}
		return msgb.toString();
	}
	
	static String
	display_status(String msg, int major, int minor)
	{
		return display_status_1(msg, major, gss.GSS_C_GSS_CODE) +
		       display_status_1(msg, minor, gss.GSS_C_MECH_CODE);
	}
	
}
