//tabstop=4
//*****************************************************************************
// Project: Orbasec
//
// File:    Kerberos_SecurityContext.java
// Date:    March 1998
//
// -------------------------------------------------------------------------
// Copyright (C) 1998 Polar Humenn
//                    All rights reserved.
// -------------------------------------------------------------------------
// $Id$
//*****************************************************************************

package orbasec.secrep.gsskrb5;

import orbasec.util.Util;
import orbasec.io.StringMarkedInputStream;

import orbasec.krb5.*;

import org.omg.Security.*;

import org.omg.SecurityLevel2.*;
import org.omg.Security.DelegationMode;

import orbasec.corba.CredUtil;
import orbasec.corba.Opaque;
import orbasec.util.*;

//----------------------------------------------------------------------/
// Kerberos_SecurityContext
/**
 * @author  Polar Humenn
 * @version $Revision$
 * @see 
 */
// Implementation notes:  
// 
//----------------------------------------------------------------------/
class Kerberos_SecurityContext
	extends    orbasec.corba.LocalObject
	implements org.omg.SecurityReplaceable.ClientSecurityContext,
	           org.omg.SecurityReplaceable.ServerSecurityContext
{
	org.omg.Security.SecurityContextType context_type_;
	public org.omg.Security.SecurityContextType
	context_type()
	{
		if (context_orientation == CLIENT)
			return org.omg.Security.SecurityContextType.ClientSecurityContext;
		else
			return org.omg.Security.SecurityContextType.ServerSecurityContext;
	}
	
	int /* org.omg.Security.SecurityContextState */ context_state_;
	public org.omg.Security.SecurityContextState
	context_state()
	{
		switch( context_state_ ){
		case Initialized:
			return org.omg.Security.SecurityContextState.SecContextInitialized;
		case Continued:
		case ContinuedGSSEstablished:
			return org.omg.Security.SecurityContextState.SecContextContinued;
		case Established:
			return org.omg.Security.SecurityContextState.SecContextEstablished;
		case Invalid:
			return org.omg.Security.SecurityContextState.SecContextInvalid;
		default:
			return null;
		}
	}
	
	String mechanism_;
	public String /* org.omg.Security.MechanismType */
	mechanism()
	{
		return mechanism_;
	}
	
	ChannelBindings chan_bindings_;
	public ChannelBindings
	chan_binding()
	{
		return chan_bindings_;
	}
	
	short options_used_;
	public short association_options_used()
	{
		return options_used_;
	}
	
	org.omg.Security.DelegationMode delegation_mode_;
	public org.omg.Security.DelegationMode
	delegation_mode()
	{
		return delegation_mode_;
	}
	
	orbasec.corba.SecurityFeatures features_;
    public orbasec.corba.SecurityFeatures
    features()
    {
    	return features_;
    }
    
	// For ClientSecurityContext.
	
	byte[] /* org.omg.Securty.Opaque */ mech_data_;
	public byte[] /* org.omg.Securty.Opaque */
	mech_data()
	{
		if (context_orientation != CLIENT)
			throw new org.omg.CORBA.BAD_OPERATION(
						"Only on ClientSecurityContext.",
						orbasec.corba.MinorBadOperation.SecurityContext.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		return mech_data_;
	}
	
	Kerberos_Credentials client_credentials_;
	public org.omg.SecurityLevel2.Credentials
	client_credentials()
	{
		if (context_orientation != CLIENT)
			throw new org.omg.CORBA.BAD_OPERATION(
						"Only on ClientSecurityContext.",
						orbasec.corba.MinorBadOperation.SecurityContext.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);

		return client_credentials_;
	}
	
	// For Both Client And Server Security Contexts
	short server_options_supported_;
	public short server_options_supported()
	{
		return server_options_supported_;
	}
	
	short server_options_required_;
	public short server_options_required()
	{
		return server_options_required_;
	}
	
	String server_security_name_;
	public byte[] /* org.omg.Security.SecurityName */
	server_security_name()
	{
		return server_security_name_.getBytes();
	}
	
	// SecurityContext
	Kerberos_Credentials peer_credentials_;
    public org.omg.SecurityLevel2.ReceivedCredentials
    received_credentials()
    {
		if (context_orientation != SERVER)
			throw new org.omg.CORBA.BAD_OPERATION(
						"Only on ServerSecurityContext.",
						orbasec.corba.MinorBadOperation.SecurityContext.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		
    	return (org.omg.SecurityLevel2.ReceivedCredentials)peer_credentials_;
    }
    
    public org.omg.SecurityLevel2.Credentials
    peer_credentials()
    {
    	return peer_credentials_;
    }
    
    public org.omg.SecurityLevel2.TargetCredentials
    target_credentials()
    {
		if (context_orientation != CLIENT)
			throw new org.omg.CORBA.BAD_OPERATION(
						"Only on ServerSecurityContext.",
						orbasec.corba.MinorBadOperation.SecurityContext.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		
    	return (org.omg.SecurityLevel2.TargetCredentials) peer_credentials_;
    }
    
	Kerberos_Credentials server_credentials_;
	public org.omg.SecurityLevel2.Credentials
	server_credentials()
	{
		if (context_orientation != SERVER)
			throw new org.omg.CORBA.BAD_OPERATION(
						"Only on ServerSecurityContext.",
						orbasec.corba.MinorBadOperation.SecurityContext.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		
		return server_credentials_;
	}

	/** Accepting options. When context is accepted on Server side */
	short /* org.omg.Security.Association Options */ association_options_used_;
	
	// Used by creating client credentials.
	// Will throw error if delegation mode cannot be set.
	void
	check_set_delegation(Kerberos_Credentials            creds,
				         Kerberos_SecurityContext        context,
	                     org.omg.Security.DelegationMode delegation_mode)
	{
    	switch (delegation_mode.value()) {
    	case DelegationMode._SecDelModeNoDelegation:
    		// Means that these credentials are not to be delegated.
    		features_._A_no_delegation(true);
    		break;
    	case DelegationMode._SecDelModeSimpleDelegation:
     		// Doesn't matter if they are receive or own credentials.
    		// We just have to know whether they may be delegated.
     		if( creds._A_can_be_delegated()) {
				features_._A_simple_delegation(true);
				features_._A_no_delegation(false);
			} else
				throw new org.omg.CORBA.BAD_PARAM(
					"Credentials cannot be delegated.",
					orbasec.corba.MinorBadParam.SecurityContext.value(),
					org.omg.CORBA.CompletionStatus.COMPLETED_NO);
   		break;
    	case DelegationMode._SecDelModeCompositeDelegation:
			throw new org.omg.CORBA.BAD_PARAM(
				"Composite Delegation is not supported.",
				orbasec.corba.MinorBadParam.SecurityContext.value(),
				org.omg.CORBA.CompletionStatus.COMPLETED_NO);
     	default:
    		throw new org.omg.CORBA.INTERNAL(
					"Bad DelegationMode value.",
					orbasec.corba.MinorInternal.BadEnumValue.value(),
					org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    	}
	}
	
	//
	// Used by creating client context
	//
	void
	check_set_server_options(Kerberos_Credentials creds,
	                         short                options, 
	                         byte[]               mech_data)
	{
		// We need to set the server_options_supported and
		// server_options required. We will get this from
		// the mechanism data, which is parsable by SECIOP.
		orbasec.corba.CDRBuffer inbuf = new
			orbasec.corba.CDRBuffer(mech_data,0,mech_data.length);
		inbuf.readEndian();
		orbasec.corba.CDRDecoder in = new orbasec.corba.CDRDecoder(inbuf);
		org.omg.SECIOP.KerberosV5 krb5 =
			org.omg.SECIOP.KerberosV5Helper.read(in);
		server_options_supported_ = krb5.target_supports;
		server_options_required_  = krb5.target_requires;
		
		// We must check that the association options can be supported
		// by both our credentials and the target.
		if (options != (server_options_supported_ & options))
			throw new org.omg.CORBA.BAD_PARAM("     Target does not support all the selected options of " 
			               + CredUtil.toString(options) +
						   ", target only supports " + CredUtil.toString(server_options_supported_),
						   orbasec.corba.MinorBadParam.SecurityContext.value(),
						   org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		if (server_options_required_ != (server_options_required_ & creds.invocation_options_supported()))
			throw new org.omg.CORBA.BAD_PARAM("     Target requires more than the selected options of 0x" 
			              + CredUtil.toString(creds.invocation_options_supported()) +
						  ", target requires " + CredUtil.toString(server_options_required_),
						   orbasec.corba.MinorBadParam.SecurityContext.value(),
						   org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		// check credentials for support of options.
		short reqopts = creds.invocation_options_required();
		if (reqopts != (options & reqopts)) {
			throw new org.omg.CORBA.BAD_PARAM("     Credentials require more than the selected options of " 
			              + CredUtil.toString(options) +
						  ", credentials require " + CredUtil.toString(reqopts),
						   orbasec.corba.MinorBadParam.SecurityContext.value(),
						   org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		}
		features_._A_set_from_options(options);
	}
	
	// List of trusted authorites.
	orbasec.util.List authorities_;
	
	String conf_file_;
	
	// Client Side Context
	Kerberos_SecurityContext(Kerberos_Credentials creds,
	                         byte[] /* SecurityName */ target_security_name,
							 DelegationMode       delegation_mode,
							 short  /* AssociationOptions */ options,
							 String               mechanism, // Shouldn't matter.
							 byte[]               mech_data,
							 ChannelBindings      chan_bindings)
	{
		// This is a client context.
		context_orientation   = CLIENT;
		context_state_        = 0;
		server_security_name_ = new String(target_security_name); // Its a string.
		mechanism_    		  = mechanism;
		mech_data_    		  = mech_data;
		chan_bindings_ 		  = chan_bindings;
		conf_file_            = creds.conf_file_;
		
		features_ = new orbasec.corba.SecurityFeatures();
		
		// Check and set context for Delegation Mode
		// will throw BAD_PARAM if cannot set.
		check_set_delegation(creds,this,delegation_mode);
		client_credentials_ = creds;
		
		// Options must always have DetectReplay
		options |= org.omg.Security.DetectReplay.value;
		
		check_set_server_options(creds,options,mech_data);
		
		// Features will be set after initialization;
		authorities_ = Kerberos_Vault.getClientPeerAuthorities();
	}
	
	// Server Side Context
	Kerberos_SecurityContext(Kerberos_Credentials accepting_creds,
							 ChannelBindings      chan_bindings)
	{
		context_orientation   = SERVER;
		context_state_        = 0; 
		mechanism_            = Kerberos_Vault.VAULT_MECHANISM;
		chan_bindings_        = chan_bindings;
		conf_file_            = accepting_creds.conf_file_;
		features_             = new orbasec.corba.SecurityFeatures();
		server_security_name_ = new String(orbasec.corba.CredUtil.getAccessId(accepting_creds));
	
		server_credentials_   = accepting_creds;
		
		server_options_supported_ = accepting_creds.accepting_options_supported();
		server_options_required_  = accepting_creds.accepting_options_required();

		client_credentials_ = null;
		mech_data_          = null;
		
		authorities_ = Kerberos_Vault.getServerPeerAuthorities();
	}
	
	/**
	 * If we are supporting kerberos delegation we need to copy
	 * cache files! Ugggh!! This is bizzare. Their GSS implementation
	 * has no way of just carrying credentials without a file.
	 * <p>
	 * And another thing, if we accept delegated credentials, we
	 * hose our cache file with the clients TGT! Tell me that is 
	 * isn't f*cked up.
	 * <p>
	 * Anyway, delegation is not such a good thing anyway.
	 */
	String               cred_cache_file;
	String               keytab;
	
	/**
	 * This context is valid when it is created.
	 * we have no other use for this flag unless we destroy() the
	 * context.
	 */
	boolean              valid = true;
	
	/**
	 * This attribute tells us if the context was started by
	 * a client, or accepted by a target.
	 */
	int    context_orientation;
	
	/**
	 * Values for context_orientation.
	 */
	final static int 
	CLIENT = org.omg.Security.SecurityContextType._ClientSecurityContext, 
	SERVER = org.omg.Security.SecurityContextType._ServerSecurityContext; 

	/**
	 * Values for context_state.
	 * We add one state, that is for the HALF_COMPLETE state, sort of
	 * It is between the Continued state but below the Established
	 * state. The Established state means that the CompleteEstablishment
	 * message has made it back. For cases where Mutual authenticatetion
	 * is not required, then the state goes beyoned continued, in the 
	 * GSS sense to already established. However, we need an indiator
	 * to tell whether we need a GSS Continue or we are already established
	 * waiting for the CompleteMessage. Giving a token to the 
	 * GSS Security Context whilst already established yeilds an exception.
	 */
	// arbitrary ordered values such that internal values may be added
	final static int 
	Initialized = 100,
	Continued   = 200,
	ContinuedGSSEstablished = Continued + 5,
	Established = 300,
	Invalid     = 400;
	
 
 
 
	 //------------------------------------------------------------------/
    // continue_security_context
    /**
     * This method is invoked to continue establishment of the security
     * association. 
     *     
     * @param  in_token  The security token generated by the other one of
     *                   the client-target pair and sent to this Security
     *                   Context object to be used to continue the dialogue
     *                   between client and the target to establish context
     * @param  out_token If required, a further security token to be returned
     *                   to the other Security Context object to continue the 
     *                   dialogue
     *
     * @return AssociationStatus association status
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
    public AssociationStatus
    continue_security_context( OpaqueBuffer       in_token,
                               OpaqueBufferHolder out_token )
    {
		if (context_state_ < Continued || context_state_ >= Established)
			throw new org.omg.CORBA.INTERNAL(
						"Bad security context state",
						orbasec.corba.MinorInternal.SecurityContext.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);
			
		try {
			return internal_continue_security_context(in_token,out_token);
		} catch (GSSError gsserr) {
		    /* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos.continue_security_context:" +
				         "GSS Error: " + gsserr.getMessage());
			}
			/* END DEBUG */
			throw new org.omg.CORBA.COMM_FAILURE(
					"GSS Error: " + gsserr.getMessage(),
					orbasec.corba.MinorCommFailure.MinorGSSError.value(),
					org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		} catch (org.omg.CORBA.SystemException ex) {
			throw ex;
		} catch (java.lang.Exception jex) {
			throw new org.omg.CORBA.UNKNOWN(
					"Other Exception : " + jex.toString());
		}
	}
	
    private AssociationStatus
    internal_continue_security_context( OpaqueBuffer       in_token,
                                        OpaqueBufferHolder out_token )
    {
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"Kerberos_SecurityCcontext:internal_continue_security_context");
			Debug.println(Debug.SECIOP,"    token[" + in_token.buffer.length + "] : " + Util.toHexString(in_token.buffer));
		}
		/* END DEBUG */
		AssociationStatus ret = AssociationStatus.SecAssocFailure;
		
		//
		// We know at creation time at the Vault, what the orientation
		// of this context is. We must choose the correct continuation.
		//
		switch(context_orientation) {
		case CLIENT:
			ret = cont_init_context(in_token, out_token);
			break;
		case SERVER:
			ret = cont_accept_context(in_token, out_token);
			break;
		default:
			throw new org.omg.CORBA.INTERNAL(
					"Kerberos Context.continue_sec_ctx: Bad Context State",
					orbasec.corba.MinorInternal.SecurityContext.value(),
					org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		}
		
		return ret;
    }

    //------------------------------------------------------------------/
    // protect_message
    /**
     * This method is used to protect the client request message, or
     * the target reply message for integrity and/or confidentiality
     * according to the Quality of Protection required.
     *                          
     * @param message     The message for which protection is required
     * @param qop         Required message protection options
     * @param text_buffer The protected message, optionally encrypted.
     * @param token       The integrity checksum, if any.
     *
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
    public void
    protect_message( OpaqueBuffer       message,
                     QOP                qop,
                     OpaqueBufferHolder text_buffer,
                     OpaqueBufferHolder token )
    {
		if (context_state_ < ContinuedGSSEstablished) // We cant send messages
			new org.omg.CORBA.INTERNAL("Bad security context state");
			
		try {
			internal_protect_message(message,qop,text_buffer,token);
		} catch (GSSError gsserr) {
			throw new org.omg.CORBA.COMM_FAILURE(
								"GSS error : " + gsserr.getMessage(),
					orbasec.corba.MinorCommFailure.MinorGSSError.value(),
					org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		} catch (org.omg.CORBA.SystemException ex) {
			throw ex;
		} catch (java.lang.Exception jex) {
			throw new org.omg.CORBA.UNKNOWN(
					"Other Exception : " + jex.toString());
		}
	}
	
    public void
    internal_protect_message( 
	                 OpaqueBuffer       message,
                     QOP                qop,
                     OpaqueBufferHolder text_buffer,
                     OpaqueBufferHolder token )
    {
    	int               maj_stat;
 	  	int               conf_req_flag  = 0;
 	  	int               qop_req        = 0;
    	gss_int_holder    min_stat       = new gss_int_holder();
    	gss_int_holder    conf_state     = new gss_int_holder();
     	gss_buffer_holder out_token      = new gss_buffer_holder();
		
        switch( qop.value() ) {
        case QOP._SecQOPNoProtection:
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"KERBEROS USING NoProtection!!!!!");
			}
			/* END DEBUG */
        	
			text_buffer.value = new OpaqueBuffer(message.buffer,0,message.buffer.length);
        	token.value       = new OpaqueBuffer(new byte[0],0,0);
            break;
        case QOP._SecQOPIntegrity:
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"KERBEROS USING GET_MIC!!!!!");
			}
			/* END DEBUG */
        	conf_req_flag  = 0;
        	qop_req        = gss.GSS_C_QOP_DEFAULT;
			maj_stat       = gss.get_mic( 
			                        min_stat,
	                                gss_context,
	                                qop_req,
	                                message.buffer,
	                                out_token );
        	if (maj_stat != gss.GSS_S_COMPLETE) {
        		throw new GSSError("get_mic message", maj_stat, min_stat.value);
        	}
        	text_buffer.value = new OpaqueBuffer(message.buffer,0,message.buffer.length);
        	token.value       = new OpaqueBuffer(out_token.buffer(),0,out_token.buffer().length);
            break;
        case QOP._SecQOPConfidentiality:
        case QOP._SecQOPIntegrityAndConfidentiality:
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"KERBEROS USING WRAP!!!!!");
			}
			/* END DEBUG */
        	conf_req_flag  = 1;
        	qop_req        = gss.GSS_C_QOP_DEFAULT;
 			maj_stat = gss.wrap( min_stat,
	        				 	 gss_context,
            				 	 conf_req_flag,
            				 	 qop_req,
            				 	 message.buffer,
            				 	 conf_state,
            				 	 out_token);
        	if (maj_stat != gss.GSS_S_COMPLETE) {
        		throw new GSSError("wrapping message", maj_stat, min_stat.value);
        	}
         	text_buffer.value = new OpaqueBuffer(null,0,0); // what does null mean in this context?
         	token.value = new OpaqueBuffer(out_token.buffer(),0,out_token.buffer().length);
        	break;
        default:
        	throw new org.omg.CORBA.INTERNAL("Bad QOP value!");
        }
        
		/* START DEBUG */
        if (Debug.debug) {
        	Debug.println(Debug.SECIOP_HEXDUMPS, "MSG: ");
        	if ( message != null )
            	Debug.println(Debug.SECIOP_HEXDUMPS,  "length = " + message.buffer.length + " >> " +
                    	Util.toHexString( message.buffer ));
        	Debug.println(Debug.SECIOP_HEXDUMPS, "TOKEN: " );
        	if ( token.value != null && token.value.buffer != null )
            	Debug.println(Debug.SECIOP_HEXDUMPS, "length = " + token.value.buffer.length + " >> " +
                    	Util.toHexString( token.value.buffer  ));
        	Debug.println(Debug.SECIOP_HEXDUMPS, "DATA: " );
        	if ( text_buffer.value != null && text_buffer.value.buffer != null )
            	Debug.println(Debug.SECIOP_HEXDUMPS, "length = " + text_buffer.value.buffer.length + " >> "
                	+ Util.toHexString( text_buffer.value.buffer ) );
		}
		/* END DEBUG */
    }

    //------------------------------------------------------------------/
    // reclaim_message
    /**
     * This method is used to check a protected message for integrity
     * and optionally decrypt it, if required.
     *                          
     * @param text_buffer The protected message, optionally decrypted.
     * @param token       The integrity checksum, if any.
     * @param qop         The quality of protection applied to the protected
     *                    message
     * @param message     The message for which protection is required
     *
     * @return            false, if integrity check or unsealing fails
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
    public void
    reclaim_message( OpaqueBuffer       text_buffer,
                     OpaqueBuffer       token,
                     QOPHolder          qop,
                     OpaqueBufferHolder message )
    {
		if (context_state_ < Established) 
			throw new org.omg.CORBA.INTERNAL("Bad security context state: " + context_state_ );
		
		try {
			internal_reclaim_message( text_buffer, token, qop, message );
		} catch (GSSError gsserr) {
			throw new org.omg.CORBA.COMM_FAILURE("GSS Error: " + gsserr.getMessage());
		} catch (org.omg.CORBA.SystemException ex) {
			throw ex;
		} catch (java.lang.Exception jex) {
			throw new org.omg.CORBA.UNKNOWN(
					"Other Exception : " + jex.toString());
		}
	}
	
    private void
    internal_reclaim_message( 
	                 OpaqueBuffer       text_buffer,
                     OpaqueBuffer       token,
                     QOPHolder          qop,
                     OpaqueBufferHolder message )
    {
		// check parameters
		if ( text_buffer == null ){
			throw new InternalError( "Kerberos_SecurityContext.internal_reclaim_message: null text_buffer" );
		}
		if ( token == null ){
			throw new InternalError( "Kerberos_SecurityContext.internal_reclaim_message: null token" );
		}
		if ( message == null ){
			throw new InternalError( "Kerberos_SecurityContext.internal_reclaim_message: null message" );
		}
		
		
// 		// If we have a token length of zero, then we have no protection
// 		if (token.startpos == token.endpos) {
// 			qop.value = QOP.SecQOPNoProtection;
// 			message.value = text_buffer;
// 			return;
// 		}
// 		
    	int maj_stat;
    	gss_int_holder min_stat   = new gss_int_holder();
    	gss_int_holder conf_state = new gss_int_holder();
    	gss_int_holder qop_state  = new gss_int_holder();
    	gss_buffer_holder out_buffer = new gss_buffer_holder();
    	
    	conf_state.value = 0;
    	
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP_HEXDUMPS, "DATA  : " );
		}
		/* END DEBUG */
        if ( text_buffer.buffer != null ) {
			if (token.buffer == null || token.buffer.length == 0) {
				/* START DEBUG */
				if (Debug.debug) {
					Debug.println(Debug.SECIOP,"KERBEROS USING No Protection!!!!!");
					Debug.println(Debug.SECIOP, "length = " + text_buffer.buffer.length + " << " + Util.toHexString( text_buffer.buffer ));
				}
				/* END DEBUG */
				message.value = text_buffer;
				qop.value     = QOP.SecQOPNoProtection;
				client_credentials_.association_options_used_ |=
					NoProtection.value;
				client_credentials_.association_options_used_ &=
					~(Integrity.value | Confidentiality.value);
			} else {
				/* START DEBUG */
				if (Debug.debug) {
					Debug.println(Debug.SECIOP,"KERBEROS USING VERIFY!!!!!");
					Debug.println(Debug.SECIOP, "length = " + text_buffer.buffer.length + " << " + Util.toHexString( text_buffer.buffer ));
				}
				/* END DEBUG */
				maj_stat = gss.verify_mic( min_stat,
	        				        	   gss_context,
                						   text_buffer.buffer,
                						   token.buffer,
                						   qop_state);
				if (maj_stat != gss.GSS_S_COMPLETE){
        				throw new GSSError("verifying token", maj_stat, min_stat.value);
        		}
        		message.value = text_buffer;
				qop.value     = QOP.SecQOPIntegrity;
				client_credentials_.association_options_used_ |=
					Integrity.value;
				client_credentials_.association_options_used_ &=
					~(NoProtection.value | Confidentiality.value);
			}
        } else {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"KERBEROS USING UNWRAP!!!!!");
				Debug.println(Debug.SECIOP_HEXDUMPS, "TOKEN: " );
				Debug.println(Debug.SECIOP_HEXDUMPS, "length = " + token.buffer.length + " << " + Util.toHexString( token.buffer ));
			}
			/* END DEBUG */
	        if ( token.buffer != null ) {
				maj_stat = gss.unwrap( min_stat,
	        				    	   gss_context,
            				    	   token.buffer,
            				    	   out_buffer,
            				    	   conf_state,
            				    	   qop_state);
				if (maj_stat != gss.GSS_S_COMPLETE){
        				throw new GSSError("unwrapping message", maj_stat, min_stat.value);
        		}
        		message.value = new OpaqueBuffer(out_buffer.buffer(),0,out_buffer.buffer().length);
				if (conf_state.value == 0) {
					qop.value = QOP.SecQOPIntegrity;
					client_credentials_.association_options_used_ |=
						Integrity.value;
					client_credentials_.association_options_used_ &=
						~(NoProtection.value | Confidentiality.value);
				} else {
					qop.value = QOP.SecQOPIntegrityAndConfidentiality;
					client_credentials_.association_options_used_ |=
						Integrity.value | Confidentiality.value;
					client_credentials_.association_options_used_ &=
						~(NoProtection.value);
				}
				/* START DEBUG */
				if (Debug.debug) {
					Debug.println(Debug.SECIOP, "value = " + message.value + " conf_state = " + conf_state.value);
				}
				/* END DEBUG */
			} else {
				throw new InternalError("Kerberos_SecurityContext.reclaim_message: both buf and token are null");
			}
		}
		
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"KERBEROS QOP WAS " +qop.value.value());
			Debug.println(Debug.SECIOP_HEXDUMPS, "RECLAIMED: " + message.value.buffer.length);
			Debug.println(Debug.SECIOP_HEXDUMPS, Util.toHexString( message.value.buffer ) );
		}
		/* END DEBUG */
    }

    //------------------------------------------------------------------/
    // is_valid
    /**
     * This method is invoked to check the validity of the security context
     *                          
     * @param expiry_time  The time at which this context is no 
     *                     longer valid
     * 
     * @return true if the security context is valid, false otherwise
     *
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
    public boolean
    is_valid( org.omg.TimeBase.UtcTHolder expiry_time )
    {
        return valid;
    }


    //------------------------------------------------------------------/
    // supports_refresh
    /**
     * @return true if the mechanism implementation supports
	 * refreshment of this SecurityContext
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
	public boolean
	supports_refresh()
	{
		// not GSS
		return false;
	}

    //------------------------------------------------------------------/
    // refresh_security_context
    /**
     * This method is used to refresh the security context, if possible
     *                          
     * @return true if the security context is refreshed, false otherwise
     *
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
    public boolean
    refresh_security_context( 
	         OpaqueBuffer             refresh_data, 
             OpaqueBufferHolder       out_token )
    {
        throw new org.omg.CORBA.BAD_OPERATION();
    }

    //------------------------------------------------------------------/
    // 
    /**
     * 
     *                          
     * 
     *
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
    public boolean
    process_refresh_token( OpaqueBuffer refresh_token )
    {
        throw new org.omg.CORBA.BAD_OPERATION();
    }

    //------------------------------------------------------------------/
    // discard_security_context
    /**
     * 
     *                          
     * 
     *
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
    public boolean
    discard_security_context( 
	         byte                     discard_data[], // what with this?
			 OpaqueBufferHolder       out_token )
    {
		gss_int_holder minor_status    = new gss_int_holder();
		gss_buffer_holder output_token = new gss_buffer_holder();
		
		try {
			int major_status = gss.delete_sec_context(
				minor_status,
				gss_context,
				output_token );

			switch( major_status ){
			case gss.GSS_S_COMPLETE:
				byte output_token_buffer[] = output_token.buffer();
				out_token.value = new OpaqueBuffer(
					output_token_buffer,
					0, output_token_buffer.length );
				return true;
			case gss.GSS_S_FAILURE:
				// see minor_status for more information
				return false;
			case gss.GSS_S_NO_CONTEXT:
				// bad context
				return false;
			default:
				return false;
			}
		} catch (GSSError gsserr) {
			throw new org.omg.CORBA.COMM_FAILURE(
								"GSS error : " + gsserr.getMessage(),
					orbasec.corba.MinorCommFailure.MinorGSSError.value(),
					org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		} catch (org.omg.CORBA.SystemException ex) {
			throw ex;
		} catch (java.lang.Exception jex) {
			throw new org.omg.CORBA.UNKNOWN(
					"Other Exception : " + jex.toString());
		}
	}

    //------------------------------------------------------------------/
    // process_discard_token
    /**
     * 
     *                          
     * 
     *
     */
    // Implementation notes:  
    // 
    //------------------------------------------------------------------/
    public boolean
    process_discard_token( 
	         OpaqueBuffer             discard_token )
    {
		gss_int_holder minor_status = new gss_int_holder();
		
		try {
			int major_status = gss.process_context_token(
				minor_status,
				discard_token.buffer,
				gss_context );

			switch( major_status ){
			case gss.GSS_S_COMPLETE:
				return true;
			case gss.GSS_S_DEFECTIVE_TOKEN:
				// consistency checks on token failed.
				return false;
			case gss.GSS_S_FAILURE:
				// see minor_status for more information
				return false;
			case gss.GSS_S_NO_CONTEXT:
				// bad context
				return false;
			default:
				return false;
			}
		} catch (GSSError gsserr) {
			throw new org.omg.CORBA.COMM_FAILURE(
								"GSS error : " + gsserr.getMessage(),
					orbasec.corba.MinorCommFailure.MinorGSSError.value(),
					org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		} catch (org.omg.CORBA.SystemException ex) {
			throw ex;
		} catch (java.lang.Exception jex) {
			throw new org.omg.CORBA.UNKNOWN(
					"Other Exception : " + jex.toString());
		}
    }
	
	/*
	 * Function: set_features_and_association_options_used
	 *
	 * Purpose: Sets the security features of this context
	 *          by the flags returned from gss.init_sec_context.
	 *
	 * Arguments:
	 *
	 * 	int		ret_flags
	 *
	 * Effects:
	 *
	 * Strings corresponding to the context flags are printed on
	 * stdout, preceded by "context flag: " and followed by a newline
	 */

	private void 
	print_flags(int flags)
	{
		// Has the Client autheticated us? i,e. Target Authentication?
    	if ((flags & gss.GSS_C_TRANS_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_TRANS_FLAG on!");
			}
			/* END DEBUG */
		}
    	if ((flags & gss.GSS_C_PROT_READY_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_PROT_READY_FLAG on!");
			}
			/* END DEBUG */
		}
    	if ((flags & gss.GSS_C_ANON_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_ANON_FLAG on!");
			}
			/* END DEBUG */
		}
    	if ((flags & gss.GSS_C_MUTUAL_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_MUTUAL_FLAG on!");
			}
			/* END DEBUG */
		}
    	if ((flags & gss.GSS_C_DELEG_FLAG) != 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_DELEG_FLAG on!");
			}
			/* END DEBUG */
		}
    	if ((flags & gss.GSS_C_REPLAY_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_REPLAY_FLAG on!");
			}
			/* END DEBUG */
		}
    	if ((flags & gss.GSS_C_SEQUENCE_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_SEQUENCE_FLAG on!");
			}
			/* END DEBUG */
		}
    	if ((flags & gss.GSS_C_CONF_FLAG) != 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_CONF_FLAG on!");
			}
			/* END DEBUG */
    	}
    	if ((flags & gss.GSS_C_INTEG_FLAG) != 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_INTEG_FLAG on!");
			}
			/* END DEBUG */
		}
	}
	/*
	 * Function: set_features_and_association_options_used
	 *
	 * Purpose: Sets the security features of this context
	 *          by the flags returned from gss.init_sec_context.
	 *
	 * Arguments:
	 *
	 * 	int		ret_flags
	 *
	 * Effects:
	 *
	 * Strings corresponding to the context flags are printed on
	 * stdout, preceded by "context flag: " and followed by a newline
	 */

	private void 
	set_features_and_association_options_used(int flags)
	{
		// We start out with NoDelegation.
		features_._A_no_delegation(true);
		
		// We always authenticate the client.
		features_._A_establish_trust_in_client(true);
		association_options_used_ |= org.omg.Security.EstablishTrustInClient.value;
		
		// Has the Client autheticated us? i,e. Target Authentication?
    	if ((flags & gss.GSS_C_MUTUAL_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_MUTUAL_FLAG on!");
			}
			/* END DEBUG */
			features_._A_establish_trust_in_target(true);
			association_options_used_ |= org.omg.Security.EstablishTrustInTarget.value;
		}
		//
		// If the delegation flag is on, we've just got our credentials
		// cached hosed by Kerberos GSS. If we are paying attention
		// then if the mutual flag is set as well, turn on the Trustin Target
		// feature for this context.
		//
    	if ((flags & gss.GSS_C_DELEG_FLAG) != 0) {
			// This is a received context. So our supported features
			// must state that we can do unrestricted delegation.
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_DELEG_FLAG on!");
			}
			/* END DEBUG */
			features_._A_no_delegation(false);
			features_._A_simple_delegation(true);
		}
		
		//
		// We probably shouldn't be using these, but if we keep the 
		// contexts seperate it shouldn't be a problem.
		//
    	if ((flags & gss.GSS_C_REPLAY_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_REPLAY_FLAG on!");
			}
			/* END DEBUG */
			features_._A_detect_replay(true);
			association_options_used_ |= org.omg.Security.DetectReplay.value;
		}
    	if ((flags & gss.GSS_C_SEQUENCE_FLAG)!= 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_SEQUENCE_FLAG on!");
			}
			/* END DEBUG */
			features_._A_detect_misordering(true);
			association_options_used_ |= org.omg.Security.DetectMisordering.value;
		}
		
		//
		// We have confidentiality capability for this context.
		//
    	if ((flags & gss.GSS_C_CONF_FLAG) != 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_CONF_FLAG on!");
			}
			/* END DEBUG */
			features_._A_confidentiality(true);
			association_options_used_ |= org.omg.Security.Integrity.value;
			association_options_used_ |= org.omg.Security.Confidentiality.value;
    	}
    	
    	//
    	// We have integrity capability for this context.
    	// Generally, I believe both CONF and INTEG will always be on.
    	//
    	if ((flags & gss.GSS_C_INTEG_FLAG) != 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"Kerberos_SecurityContext: GSS_C_INTEG_FLAG on!");
			}
			/* END DEBUG */
			features_._A_integrity(true);
			association_options_used_ |= org.omg.Security.Integrity.value;
		}
		
		//
		// Make integ and conf reflect the truth.
		//
		if (features_.integrity() && features_.confidentiality())
			features_._A_integrity_and_confidentiality(true);
		
		association_options_used_ = features_._A_get_association_options();
	}
		 
	//
	// These variables are needed for continuity between 
	// accept_context() and subsequent cont_accept_context() calls.
	//
	gss_ctx_id_t   gss_context;
	gss_cred_id_t  gss_target_creds;
	
    //------------------------------------------------------------------/
    // accept_context
    /**
     * This method is invoked by the Kerberos_Vault from a 
     * accept_security_context.
     *
     * It starts to establish a GSS-API context as a specified service with
	 * an incoming client, and assigns context handle and associated
	 * client name.
     */
    // Implementation notes:  
    //  We first decode our initial token from it's readable wire
    //  form and then hand it off eventually to the gss.init_sec_context 
    //  routine.
    //  Remember, init_sec_context is used for both accept and continue.
    //------------------------------------------------------------------/
	AssociationStatus
	accept_context( byte[] recv_tok, OpaqueHolder out_token)
	{
		if (context_state_ != 0) // Zero is created from vault.
			throw new org.omg.CORBA.INTERNAL("Bad security context state: " + context_state_);
		context_state_ = Initialized;
		try {
			return internal_accept_context(recv_tok,out_token);
		} catch (GSSError gsserr) {
			throw new org.omg.CORBA.COMM_FAILURE(
								"GSS error : " + gsserr.getMessage(),
					orbasec.corba.MinorCommFailure.MinorGSSError.value(),
					org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		} catch (org.omg.CORBA.SystemException ex) {
			throw ex;
		} catch (java.lang.Exception jex) {
			throw new org.omg.CORBA.UNKNOWN(
					"Other Exception : " + jex.toString());
		}
	}
	
	private AssociationStatus
	internal_accept_context( byte[] recv_tok, OpaqueHolder out_token)
	{
		// We are a SERVER! Get an empty GSS context handle.
		context_orientation    = SERVER;
		gss_context            = new gss_ctx_id_t();
		
		//
		// The invocation credentials should have a good 
		// GSS credential handle.
		//
		gss_target_creds  = server_credentials_.get_gss_cred_id_t();
		
		//
		// This stupid cache file. We may have to change it out
		// if we are supporting kerberos delegation.
		//
		cred_cache_file   = server_credentials_.ccache;
		keytab            = server_credentials_.keytab;
		
		Kerberos_Credentials creds = 
		                 new Kerberos_Credentials(server_credentials_.conf_file_,
						          null/* keytab */,cred_cache_file);
		creds._A_setReceived();
		creds._A_accepting_credentials(server_credentials_);
		
		// Kerberos doesn't allow any kind of delegation specification.
		// It strickly impersonation.
		
		creds.delegation_state(DelegationState.SecInitiator);
		
		peer_credentials_        = creds;
		client_credentials_      = creds;

		AssociationStatus ret;
		
		ret = cont_accept_context1(recv_tok, out_token);
		return ret;
	}
	
    //------------------------------------------------------------------/
    // cont_accept_context
    /**
     * This method is invoked by this context in 
     * continue_security_context() after it has determinted that we
     * are a SERVER oriented context.
     *
     * It continues to establish a GSS-API context as a specified service 
     * with an incoming client, and assigns context handle and associated
	 * client name.
     */
    // Implementation notes:  
    //  We first decode our initial token from it's readable wire
    //  form and then hand it off to the gss.init_sec_context routine.
    //  Remember, accept_sec_context is used for both accept and continue.
    //------------------------------------------------------------------/
	private AssociationStatus
	cont_accept_context(OpaqueBuffer recv_tok, OpaqueBufferHolder out_token)
	{
		if (context_state_ < Continued || context_state_ >= Established)
			throw new org.omg.CORBA.INTERNAL("Bad security context state: " + context_state_);
		AssociationStatus ret;
		OpaqueHolder      out_tok = new OpaqueHolder();
		
		ret = cont_accept_context1(recv_tok.buffer, out_tok);
		
		// Create an OpaqueBuffer to return through out_token
		out_token.value          = new OpaqueBuffer();
		out_token.value.buffer   = out_tok.value;
		out_token.value.startpos = 0;
		out_token.value.endpos   = out_tok.value.length;
		
		return ret;
	}
	
	//
	// This funciton submits our decoded token for processing to the
	// gss_init_sec_context function. And encodes the result to our
	// wire format.
	//
	private AssociationStatus
	cont_accept_context1(byte[] recv_tok, OpaqueHolder out_token)
	{
			
		OpaqueHolder      out_tok = new OpaqueHolder();
		
		AssociationStatus ret = gss_accept_sec_context(recv_tok, out_tok);
		
		//
		// endcode token for the wire.
		//
		if (ret.value() != AssociationStatus._SecAssocFailure) {
		
			//
			// If we are complete, we need to send an empty token
			// back with the complete message. This only happens
			// in the case when the client do not need target 
			// authentication.
			//  (However, that doesn't seem to work on the client side).
			//
 			out_token.value = out_tok.value;
			
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP_HEXDUMPS,
				"Kerberos_SecurityContext.cont_accept_context1: ret = " +
				ret.value());
				if (out_token.value == null) {
					Debug.println(Debug.SECIOP_HEXDUMPS,
					"  out_token is null;");
				} 
				else {	
					Debug.println(Debug.SECIOP_HEXDUMPS,
					"  out_token[" + 
				    	out_token.value.length + "] = " + 
						Util.toHexString(out_token.value));
				}
			}
			/* END DEBUG */
			
			// We cannot send a null token back, so we'll send a zero
			// length, and assume that the other side will be in Continue
			// mode, awaiting the CompleteEstablishment Message.
			if (out_token.value == null)
				out_token.value = new byte[0];
		}
		return ret;
	}
	
	//
	// This function is our interface to the GSS accept_sec_context
	// function. This GSS funciton is used for initial and continuation of 
	// context establishment on the target side.
	//
	private AssociationStatus
	gss_accept_sec_context(byte[] recv_tok, OpaqueHolder out_token)
	{
		int maj_stat;
		gss_int_holder         min_stat      = new gss_int_holder();
		gss_OID                diod          = new gss_OID();
		gss_int_holder         ret_flags     = new gss_int_holder();
		gss_buffer_holder      send_tok      = new gss_buffer_holder();
		gss_name_t             client        = new gss_name_t();
		gss_string_holder      client_nameh  = new gss_string_holder();
		gss_cred_id_t          deleg_creds   = new gss_cred_id_t();
		gss_int_holder         time_rec      = new gss_int_holder();
		gss_channel_bindings_t chan_bindings = new gss_channel_bindings_t();
		
		maj_stat = gss.create_channel_bindings(
								chan_bindings_.initiator_addrtype,
								chan_bindings_.initiator_address,
								chan_bindings_.acceptor_addrtype,
								chan_bindings_.acceptor_address,
								chan_bindings_.application_data,
								chan_bindings);
		
		/* START DEBUG */
		if (Debug.debug(Debug.SECIOP)) {
			Debug.println("krb5_gss_accept_sec_context:ChannelBindings:");
			Debug.println("  ia="+Util.toHexString(chan_bindings_.initiator_address));
			Debug.println("  aa="+Util.toHexString(chan_bindings_.acceptor_address));
		}
		/* END DEBUG */						
		if (maj_stat != gss.GSS_S_COMPLETE) {
			throw new org.omg.CORBA.INTERNAL("No Memory");
		}
		
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"Kerberos_SecurityContext.gss_accept_sec_context:");
			Debug.println(Debug.SECIOP,"    recv_token["+recv_tok.length+"]");
			Debug.println(Debug.SECIOP_HEXDUMPS,Util.hexDump(recv_tok));
		}
		/* END DEBUG */
		
		// In order to deal with delegation we need to 
		// copy the cred cache file and the credentials, so we
		// don't wipe them out. (This seems really dangerous to me).
		String invoc_cred_cache = cred_cache_file;
		// VERSION STUFF
		if( gss.version.major == 1 && gss.version.minor == 0) {
			cred_cache_file = copy_cred_cache(server_credentials_);
			gss.krb_set_cache(cred_cache_file);
			client_credentials_.ccache = cred_cache_file;
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"    Accepting with new cache file " + cred_cache_file);
			}
			/* END DEBUG */
		}
		
		// VERSION STUFF!!
		// In version 1.0 we needed to set the keytab incase this was a
		// delegated credential. This is not the case any more.
		if (gss.version.major == 1 && gss.version.minor == 0)
			if (keytab != null)
				gss.krb_set_keytab(keytab);
		if (conf_file_ != null)
			gss.krb_set_config_file(conf_file_);	
		maj_stat = gss.accept_sec_context(min_stat,
		                                  gss_context,
		                                  gss_target_creds,
		                                  recv_tok,
		                                  chan_bindings,
		                                  client,
		                                  diod,
		                                  send_tok,
		                                  ret_flags,
		                                  time_rec, 
		                                  deleg_creds);	
				
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,
				"KerberosSecurityContext: gss_accept_sec_context: returns " +
					 maj_stat);
		}
		/* END DEBUG */
		//
		// Good returns should only be COMPLETE OR CONTINUE_NEEDED
		//                          	                                  
		if (maj_stat != gss.GSS_S_COMPLETE &&
		    maj_stat != gss.GSS_S_CONTINUE_NEEDED) {
			// VERSION STUFF
			// for gsslib version 1.1 and higher we no longer have to 
			// move the cache file out of the way, so we don't have to 
			// move it back here.
			if (gss.version.major == 1 && gss.version.minor == 0)
				gss.krb_set_cache(invoc_cred_cache);
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(new GSSError("accepting context", maj_stat, min_stat.value).getMessage());
			}
			/* END DEBUG */
		    throw new GSSError("accepting context", maj_stat, min_stat.value);
		}
		
		//
		// If we need to continue, we need to fill the token.
		//
		if (maj_stat == gss.GSS_S_CONTINUE_NEEDED) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"   Accept is Continued.");
				Debug.println(Debug.SECIOP_HEXDUMPS,
					"    out_token["+ send_tok.buffer().length + "] = ");
				Debug.println(Debug.SECIOP_HEXDUMPS,Util.hexDump(send_tok.buffer()));
			}
			/* END DEBUG */
			out_token.value = send_tok.buffer();
			// VERSION STUFF
			// for gsslib version 1.1 and higher we no longer have to 
			// move the cache file out of the way, so we don't have to 
			// move it back here.
			if (gss.version.major == 1 && gss.version.minor == 0)
				gss.krb_set_cache(invoc_cred_cache);
			context_state_ = Continued;
			return AssociationStatus.SecAssocContinue;
		}
		
		//
		// We are accepting the token, but we may have something to send
		// out??? Not really, but we should check here anyway.
		//
		if (send_tok.buffer().length != 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP, "   Accept is Complete.");
				Debug.println(Debug.SECIOP_HEXDUMPS,
					"   out_token["+ send_tok.buffer().length + "]");
				Debug.println(Debug.SECIOP_HEXDUMPS,Util.hexDump(send_tok.buffer()));
			}
			/* END DEBUG */
			out_token.value = send_tok.buffer();
		}
		
		//
		// Some miscellaneous checks for fun!
		//
		gss_string_holder oid_name      = new gss_string_holder();
		maj_stat = gss.oid_to_str(min_stat, diod, oid_name);
		if (maj_stat != gss.GSS_S_COMPLETE) {
		    // VERSION STUFF
			// for gsslib version 1.1 and higher we no longer have to 
			// move the cache file out of the way, so we don't have to 
			// move it back here.
			if (gss.version.major == 1 && gss.version.minor == 0)
				gss.krb_set_cache(invoc_cred_cache);
	     	throw new GSSError("converting oid->string", maj_stat, min_stat.value);
	    }
	    
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"   Accepted connection using mechanism OID " +oid_name.buffer());
		}
		/* END DEBUG */
	    
	    //
	    // Get the client name so we can stick it into the received
	    // credentials.
	    //                    
		maj_stat = gss.display_name(min_stat, client, client_nameh, diod);
		if (maj_stat != gss.GSS_S_COMPLETE) {
			// VERSION STUFF!
			// for gsslib version 1.1 and higher we no longer have to 
			// move the cache file out of the way, so we don't have to 
			// move it back here.
			if (gss.version.major == 1 && gss.version.minor == 0)
				gss.krb_set_cache(invoc_cred_cache);
			throw new GSSError("displaying name", maj_stat, min_stat.value);
	    }
	    
		//
		// Okay, lets set the features of this context, Create the 
		// received credentials.  These are kind of bogus credentials,
		// since in the gss, we are a target, and we don't have the
		// credentials of the client, the GSS context carries that
		// information. 
		// @@@@@ We might have to tie the two together later to 
		// get "is_valid" and other stuff like that to work correctly.
		//
		set_features_and_association_options_used(ret_flags.value);
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"Kerberos_SecurityContextContext Accepted");
			Debug.println(Debug.SECIOP,"GSS Flags: " + 
						Integer.toHexString(ret_flags.value));
			Debug.println(Debug.SECIOP,"Features: " + features_);
		}
		/* END DEBUG */
		
		
		client_credentials_.features_ = features_._A_copy();
		client_credentials_.association_options_used_ = association_options_used_;
		client_credentials_._A_set_access_id(client_nameh.buffer());
		client_credentials_._A_accepting_credentials(server_credentials_);
		//client_credentials_._A_orientation(org.omg.Security.SecOrientation.SecServerOrientation);
		if (!Kerberos_Vault.verifyAuthority(
							client_credentials_._A_get_issuer_id(),
		                    authorities_)) {
				return AssociationStatus.SecAssocFailure;
		}
		if ((ret_flags.value & gss.GSS_C_DELEG_FLAG) != 0) {
  			client_credentials_._A_set_simple_delegate();
			client_credentials_.invocation_options_supported_ |= org.omg.Security.SimpleDelegation.value;
  			
			// Deleg_creds parameter from gss_accept_sec_context
			// doesn't work in the Jgsskrb5 1.0 version.
			// The handle always comes back 0.
			// client_credentials_.gss_creds = deleg_creds;

			// A delegated credential writes over our target creds! In version 1.0
			if (gss.version.major == 1 && gss.version.minor == 0 ) {
				// The following is already set.
				//client_credentials_.gss_creds = new gss_creds_id_t(); 
				// This causes to get the "default" ccache
				// which is set by gss.krb5_set_ccache().
			} else {
				// This should presently work with Jgsskrb5 1.1
				client_credentials_.gss_creds = deleg_creds;
			}
		} else {
			client_credentials_._A_set_no_delegate();
			// No delegation, no invocation!
			client_credentials_.invocation_options_supported_ = 0;
			client_credentials_.invocation_options_required_  = 0; // Important!
		}
		

		context_state_ = Established;
		return AssociationStatus.SecAssocSuccess;
	}
	
	//
	// These attributes are needed for continuity between
	// init_sec_context and continue_sec_context.
	//
	int           gss_client_options;
	gss_cred_id_t gss_client_creds;
	String        target_security_name;
	
    //------------------------------------------------------------------/
    // init_context
    /**
     * This method is invoked by the Kerberos_Vault from a 
     * init_security_context.
     *
     * It starts to establish a GSS-API context as a specified service with
	 * a remote target, and assigns context handle and associated
	 * client name.
     */
    // Implementation notes:  
    //  We first set some initial context orientation variables.
    //  and then hand it off to the gss.init_sec_context routine.
    //  Remember, init_sec_context is used for both init and continue.
    //------------------------------------------------------------------/
	AssociationStatus
	init_context(byte[] /* org.omg.Security.SecurityName */ tname, 
	             OptionsDirectionPair[] options, 
	             DelegationMode delmode,
	             OpaqueHolder out_token)
	{
		context_orientation  = CLIENT;
		gss_context          = new gss_ctx_id_t();
		target_security_name = new String(tname);
		gss_client_creds     = client_credentials_.get_gss_cred_id_t();
		gss_client_options   = convert_options_to_gss(options,delmode);
		cred_cache_file      = client_credentials_.ccache;
		keytab               = client_credentials_.keytab;
		
		server_security_name_ = new String(tname);
		
		AssociationStatus ret;
		OpaqueHolder      out_tok = new OpaqueHolder();
		
		ret = gss_init_sec_context( new byte[0], out_tok );
		
		if (ret.value() != AssociationStatus._SecAssocFailure) {
			if (out_tok.value == null)
				out_token.value = new byte[0]; // This should never happen;
			else
				out_token.value = out_tok.value;
		}	
		return ret;
	}
	
    //------------------------------------------------------------------/
    // cont_init_context
    /**
     * This method is invoked by this context in 
     * continue_security_context() after it has determinted that we
     * are a CLIENT oriented context.
     *
     * It continues to establish a GSS-API context as a specified service 
     * with a target, and assigns context handle and associated
	 * client name.
     */
    // Implementation notes:  
    //  We first decode our initial token from it's readable wire
    //  form and then hand it off to the gss.init_sec_context routine.
    //  Remember, init_sec_context is used for both init and continue.
    //------------------------------------------------------------------/
	private AssociationStatus
	cont_init_context(
		OpaqueBuffer       recv_tok, 
		OpaqueBufferHolder out_token)
	{
		AssociationStatus ret;
		OpaqueHolder      out_tok = new OpaqueHolder();
		
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP_HEXDUMPS,
				"Kerberos_SecurityContext.cont_init_context: recv_tok.buffer[" + 
				    recv_tok.buffer.length + "] = " + 
					Util.toHexString(recv_tok.buffer));
		}
		/* END DEBUG */
		
		if (context_state_ == ContinuedGSSEstablished) {
			if (recv_tok.buffer.length != 0) {
				throw new org.omg.CORBA.COMM_FAILURE(
						"Zero SECIOP Token Received",
						orbasec.corba.MinorCommFailure.MinorRecvZero.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);
			}
			// We got the CompleteEstablishment back
			context_state_ = Established;
			return AssociationStatus.SecAssocSuccess;
		} else {
			// We are still continued. Got to GSS
			ret = gss_init_sec_context(recv_tok.buffer, out_tok);
			
			// We are a Client.  If return is Continue, then we
			// should have a token, which we place on the OpaqueBuffer.
			if ( ret == AssociationStatus.SecAssocContinue ){
				out_token.value = new OpaqueBuffer(
					out_tok.value,
					0,
					out_tok.value.length);
			}
		}
		return ret;
	}
	
	//
	// This function calls the GSS init_sec_context. This function 
	// is used both for the initial and continuation of establishing 
	// a context with at target.
	//
	private AssociationStatus
	gss_init_sec_context(byte[] recv_token,
	              OpaqueHolder out_token)
	{
		int maj_stat;
		gss_int_holder    	   min_stat   	 = new gss_int_holder();
		gss_name_t        	   target_name	 = new gss_name_t();
		gss_buffer_holder 	   send_tok   	 = new gss_buffer_holder();
		gss_int_holder    	   ret_flags  	 = new gss_int_holder();
		gss_channel_bindings_t chan_bindings = new gss_channel_bindings_t();
		
		if (conf_file_ != null)
			gss.krb_set_config_file(conf_file_);
		
		maj_stat = gss.create_channel_bindings(
								chan_bindings_.initiator_addrtype,
								chan_bindings_.initiator_address,
								chan_bindings_.acceptor_addrtype,
								chan_bindings_.acceptor_address,
								chan_bindings_.application_data,
								chan_bindings);
								
		if (maj_stat != gss.GSS_S_COMPLETE) {
			throw new org.omg.CORBA.INTERNAL("No Memory");
		}
		
		
		maj_stat = gss.import_name(min_stat, target_security_name,
		                           gss.gss_nt_user_name, target_name);
		                           
		if (maj_stat != gss.GSS_S_COMPLETE) {
			throw new GSSError( "parsing target name", maj_stat, min_stat.value);
		}

		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"Kerberos_SecurityContext.init_sec_context: flags " + 
				Integer.toHexString(gss_client_options));
		}
		/* END DEBUG */
		
	    //
	    // Get the target name
	    //
	    gss_string_holder tnameh = new gss_string_holder();
	    gss_OID           diod   = new gss_OID();
		maj_stat = gss.display_name(min_stat, target_name, tnameh, diod);
		if (maj_stat != gss.GSS_S_COMPLETE) {
			throw new GSSError("displaying name", maj_stat, min_stat.value);
	    }

		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"init_sec_context: imported target name =" + tnameh.buffer());
		}
		/* END DEBUG */
	
		// See if the realm is trustes. We make an access id out of it first
		Opaque authority = Kerberos_Credentials
									._A_issuerIdOf(tnameh.buffer());
		if (!Kerberos_Vault.verifyAuthority(authority,authorities_)) {
			throw new org.omg.CORBA.NO_PERMISSION(
						"Violation of trusted authority policy",
						orbasec.corba.MinorNoPermission.PolicyViolation.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);
		}
		
		gss_string_holder oid_name      = new gss_string_holder();
		maj_stat = gss.oid_to_str(min_stat, diod, oid_name);
		if (maj_stat != gss.GSS_S_COMPLETE) {
	     	throw new GSSError("converting oid->string", maj_stat, min_stat.value);
	    }
	    
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"The name has type " +oid_name.buffer());
		}
		/* END DEBUG */

		// VERSION STUFF!
		if (gss.version.major == 1 && gss.version.minor == 0)
			gss.krb_set_cache(cred_cache_file);

		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"Initing with cache file " + cred_cache_file);
			Debug.println(Debug.SECIOP,"Kerberos_Cedentials.inquire = " + client_credentials_._A_inquire());
			Debug.println(Debug.SECIOP,"Initing with cache file " + cred_cache_file);
			Debug.println(Debug.SECIOP,"gss_client_creds = " + gss_client_creds.handle);
			Debug.println(Debug.SECIOP,"gss_context 	 = " + Integer.toHexString(gss_context.handle));
			Debug.println(Debug.SECIOP,"target_name 	 = " + Integer.toHexString(target_name.handle));
			Debug.println(Debug.SECIOP,"gss_client_options = " + Integer.toHexString(gss_client_options));
			Debug.println(Debug.SECIOP,"ret_flags		 = " + Integer.toHexString(ret_flags.value));
			Debug.println(Debug.SECIOP,"recv_token.len   = " + recv_token.length);
			Debug.println(Debug.SECIOP,"send_tok.len	 = " + send_tok.buff.length);
			print_flags(gss_client_options);
		}
		/* END DEBUG */
		if (conf_file_ != null)
			gss.krb_set_config_file(conf_file_);
		
		maj_stat = gss.init_sec_context(min_stat,
							gss_client_creds,
							gss_context,
							target_name,
							gss.GSS_C_NO_OID, // default mechanism, kerberos
							gss_client_options,
							0,
							chan_bindings,
							recv_token,
							null, // ignore mech type
							send_tok,
							ret_flags,
							null); // ignore time_rec
														
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"init_sec_context: client options  0x" + Integer.toHexString(gss_client_options));
			Debug.println(Debug.SECIOP,"                  actual options  0x" + Integer.toHexString(ret_flags.value));
			print_flags(ret_flags.value);
		}
		/* END DEBUG */
		

		if (maj_stat != gss.GSS_S_COMPLETE &&
			maj_stat != gss.GSS_S_CONTINUE_NEEDED ) {
			throw new GSSError("initializing context", maj_stat, min_stat.value);
		}
		
		AssociationStatus ret;
		//
		// If we are complete but have a token to send, then we should
		// be returning a SecAssocContinue.
		//
		if (send_tok.buffer().length != 0) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP_HEXDUMPS,
					"Sending GSSKRB5 accept_sec_context token (Complete) (size="+ 
					send_tok.buffer().length + ") :");
				Debug.println(Debug.SECIOP_HEXDUMPS,
					Util.hexDump(send_tok.buffer()));
			}
			/* END DEBUG */
			out_token.value = send_tok.buffer();
		}
		
		if (maj_stat == gss.GSS_S_COMPLETE ) {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"init_sec_context: COMPLETE ON INIT " + Integer.toHexString(ret_flags.value));
			}
			/* END DEBUG */
			if (context_state_ == Continued ) {
				context_state_ = Established;
			} else {
				context_state_ = ContinuedGSSEstablished;
			}
			ret            = AssociationStatus.SecAssocSuccess;
			assignTargetCredentials();
		} else {
			/* START DEBUG */
			if (Debug.debug) {
				Debug.println(Debug.SECIOP,"init_sec_context: CONITNUE ON INIT " + Integer.toHexString(ret_flags.value));
			}
			/* END DEBUG */
			context_state_  = Continued;
			ret             = AssociationStatus.SecAssocContinue;
		}
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"Init_sec_context id = " + gss_context.handle);
		}
		/* END DEBUG */
		return ret;
	}

	private void
	assignTargetCredentials()
	{
		int maj_stat;
		gss_int_holder min_stat = new gss_int_holder();
 		gss_name_t initiator = new gss_name_t();
		gss_name_t acceptor  = new gss_name_t();
		gss_int_holder lifetime = new gss_int_holder();
		gss_OID          oid = new gss_OID();
		gss_int_holder ret_flags1 = new gss_int_holder();
		gss_int_holder locally_initiated = new gss_int_holder();
		gss_int_holder open = new gss_int_holder();

		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"assignTargetCredentials");
		}
		/* END DEBUG */
		maj_stat = gss.inquire_context( min_stat,
			                            gss_context,
										initiator,
										acceptor,
										lifetime,
										oid,//oid, causes funky things to happen later.
										ret_flags1,
										locally_initiated,
										open);
		if (maj_stat != gss.GSS_S_COMPLETE ) {
			throw new GSSError("inquire_context", maj_stat, min_stat.value);
		}
		gss_string_holder sname = new gss_string_holder();
		gss_OID           name_type = new gss_OID();
		maj_stat = gss.display_name(min_stat, acceptor, sname, name_type);
		if (maj_stat != gss.GSS_S_COMPLETE ) {
			throw new GSSError("displaying acceptor name", maj_stat, min_stat.value);
		}
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"assignTargetCredentials: peer is "
			          + sname.buffer());
		}
		/* END DEBUG */
		set_features_and_association_options_used(ret_flags1.value);
		server_credentials_ = new Kerberos_Credentials(null,null,null);
		server_credentials_._A_setTarget();
		server_credentials_.features_ = features_._A_copy();
		server_credentials_.association_options_used_ = association_options_used_;
		server_credentials_._A_set_access_id(sname.buffer());
		server_credentials_._A_initiating_credentials(client_credentials_);
		//server_credentials_._A_orientation(org.omg.Security.SecOrientation.SecClientOrientation);
		if (!Kerberos_Vault.verifyAuthority(
							server_credentials_._A_get_issuer_id(),
		                    authorities_)) {
			throw new org.omg.CORBA.NO_PERMISSION(
						"Violation of trusted authority policy",
						orbasec.corba.MinorNoPermission.PolicyViolation.value(),
						org.omg.CORBA.CompletionStatus.COMPLETED_NO);			
		}
		server_credentials_._A_set_no_delegate();
		// No delegation, no invocation!
		server_credentials_.invocation_options_supported_ = 0;
		server_credentials_.invocation_options_required_  = 0;
		peer_credentials_ = server_credentials_; // Important!
	}


    //----------------------------------------------------------------------
    //  private attributes
    //----------------------------------------------------------------------
    private static final int STATE_CONTRADICTION = 128 ;
    
	/**
	 * This array converts the SecurityLevel2 association options
	 * to GSS context options.
	 * NoProtection           = 0x01
	 * Integrity              = 0x02
	 * Confidentiality        = 0x04
	 * DetectReplay           = 0x08
	 * DetectMisordering      = 0x10
	 * EstablishTrustInTarget = 0x20
	 * EstablishTrustInClient = 0x40
	 */
    private static final int[] vault_to_gss = {
        /*  0 */ STATE_CONTRADICTION,
        /*  1 */ STATE_CONTRADICTION,
        /*  2 */ gss.GSS_C_INTEG_FLAG,
        /*  3 */ STATE_CONTRADICTION,
        /*  4 */ gss.GSS_C_CONF_FLAG,
        /*  5 */ STATE_CONTRADICTION,
        /*  6 */ (gss.GSS_C_INTEG_FLAG | gss.GSS_C_CONF_FLAG),
        /*  7 */ STATE_CONTRADICTION,
        /*  8 */ gss.GSS_C_REPLAY_FLAG,
        /*  8 */ STATE_CONTRADICTION,
        /*  A */ (gss.GSS_C_REPLAY_FLAG | gss.GSS_C_INTEG_FLAG),
        /*  B */ STATE_CONTRADICTION,
        /*  C */ (gss.GSS_C_REPLAY_FLAG | gss.GSS_C_CONF_FLAG),
        /*  D */ STATE_CONTRADICTION,
        /*  E */ (gss.GSS_C_REPLAY_FLAG | gss.GSS_C_CONF_FLAG | gss.GSS_C_INTEG_FLAG),
        /*  F */ STATE_CONTRADICTION,
        /* 10 */ gss.GSS_C_SEQUENCE_FLAG,
        /* 11 */ STATE_CONTRADICTION,
        /* 12 */ (gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 13 */ STATE_CONTRADICTION,
        /* 14 */ (gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_CONF_FLAG),
        /* 15 */ STATE_CONTRADICTION,
        /* 16 */ (gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_CONF_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 17 */ STATE_CONTRADICTION,
        /* 18 */ (gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_REPLAY_FLAG),
        /* 19 */ STATE_CONTRADICTION,
        /* 1A */ (gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 1B */ STATE_CONTRADICTION,
        /* 1C */ (gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_CONF_FLAG),
        /* 1D */ STATE_CONTRADICTION,
        /* 1E */ (gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_CONF_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 1F */ STATE_CONTRADICTION,
        /* 20 */ gss.GSS_C_MUTUAL_FLAG,
        /* 21 */ STATE_CONTRADICTION,
        /* 22 */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 23 */ STATE_CONTRADICTION,
        /* 24 */ gss.GSS_C_CONF_FLAG,
        /* 25 */ STATE_CONTRADICTION,
        /* 26 */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_CONF_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 27 */ STATE_CONTRADICTION,
        /* 28 */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_REPLAY_FLAG),
        /* 29 */ STATE_CONTRADICTION,
        /* 2A */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 2B */ STATE_CONTRADICTION,
        /* 2C */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_CONF_FLAG),
        /* 2D */ STATE_CONTRADICTION,
        /* 2E */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_CONF_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 2F */ STATE_CONTRADICTION,
        /* 30 */ gss.GSS_C_SEQUENCE_FLAG,
        /* 31 */ STATE_CONTRADICTION,
        /* 32 */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 33 */ STATE_CONTRADICTION,
        /* 34 */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_CONF_FLAG),
        /* 35 */ STATE_CONTRADICTION,
        /* 36 */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_CONF_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 38 */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_REPLAY_FLAG),
        /* 39 */ STATE_CONTRADICTION,
        /* 3A */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 3B */ STATE_CONTRADICTION,
        /* 3C */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_CONF_FLAG),
        /* 3D */ STATE_CONTRADICTION,
        /* 3E */ (gss.GSS_C_MUTUAL_FLAG | gss.GSS_C_SEQUENCE_FLAG | gss.GSS_C_REPLAY_FLAG | gss.GSS_C_CONF_FLAG | gss.GSS_C_INTEG_FLAG),
        /* 3F */ STATE_CONTRADICTION
    };

    private static int
    convert_options_to_gss( OptionsDirectionPair[] options, DelegationMode dm )
    {
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"Kerberos_Vault:SecurityContext options are : " + options);
		}
		/* END DEBUG */
    	if (options == null)
    		return 0;
    		
    	if (options.length == 0)
    		return 0;
    		
    	short option = options[0].options;
    	
        int ctx_opts = vault_to_gss[ option & 0x3f ];

        // check the delegation mode and set the GSS_C_DELEG_FLAG 
        
        if ( dm.value() !=  DelegationMode._SecDelModeNoDelegation )
            ctx_opts |= gss.GSS_C_DELEG_FLAG;
		/* START DEBUG */
		if (Debug.debug) {
			Debug.println(Debug.SECIOP,"Kerberos_Vault:SecurityContext convert options are : " + Integer.toHexString(option));
			Debug.println(Debug.SECIOP,"                           to gss options are : " + Integer.toHexString(ctx_opts));
		}
		/* END DEBUG */
		
        return ctx_opts;
    }

	static int file_counter = 1;
	private String
	copy_cred_cache(Kerberos_Credentials creds)
	{
		String in_file_name  = creds.ccache;
		String out_file_name = creds.ccache + "-deleg-" + file_counter++;
		// This call ignores whether the in_file is there or not.
		Util.copyFile(out_file_name, in_file_name);
		return out_file_name;
	}
	
	void destroy()
	{
		java.io.File f = new java.io.File(cred_cache_file);		
		f.delete();
	}
	
	public void 
	finalize()
	{
		destroy();
	}
	
}
